#include "CAN_saj1000.c"
#include "CAN_functions.h"

SJAinit_t SJA_Init_Structure; /* Structure to initialize the SJA1000 */
Message_t SJA_Message; /* the message */
u08 message = 0x01; /* demovalue for the message */

void check_SJA1000_chip (void)
 {
  sprintf(s, "Stat=%X", RD(StatusReg));lcd_WR_string(LCD_L4,&s[0]);
 
  WR(AcceptCode0Reg, 0x03);
  sprintf(s, "ACR0=%X", (RD(AcceptCode0Reg)));lcd_WR_string(LCD_L1,&s[0]);
  delms(500);
  WR(AcceptCode0Reg, 0x06);
  sprintf(s, "ACR1=%X", (RD(AcceptCode0Reg)));lcd_WR_string(LCD_L1,&s[0]);
  delms(500);
  WR(AcceptCode0Reg, 0x09);
  sprintf(s, "ACR2=%X", (RD(AcceptCode0Reg)));lcd_WR_string(LCD_L1,&s[0]);
  delms(500);
  
  WR(TxBuffer1, 0x60);
  sprintf(s, "Tx=%X", (RD(TxBuffer1)));lcd_WR_string(LCD_L1,&s[0]);
  delms(500);
  WR(TxBuffer1, 0x85);
  sprintf(s, "ACR1=%X", (RD(TxBuffer1)));lcd_WR_string(LCD_L1,&s[0]);
  delms(500);
  WR(AcceptCode0Reg, 0x09);
  sprintf(s, "ACR2=%X", (RD(AcceptCode0Reg)));lcd_WR_string(LCD_L1,&s[0]);
  delms(500);
  
  sprintf(s, "MCR1=%X", RD(ModeControlReg));lcd_WR_string(LCD_L2,&s[0]);
  WR(ModeControlReg, 0x01);
  //WR(ModeControlReg, (RD(ModeControlReg) | RM_RR_Bit));
  
  sprintf(s, "MCR2writ=%X", RD(ModeControlReg));lcd_WR_string(LCD_L3,&s[0]);
  
  
  delms(300); 
 }
void messageDemo(void)
 {SJA_Message.TxBuffer[0] = TC0;
  SJA_Message.TxBuffer[1] = TC1;
  SJA_Message.TxBuffer[2] = TC2;
  SJA_Message.TxBuffer[3] = message;
  SJA_Message.TxBuffer[4] = message+1;
  SJA_Message.TxBuffer[5] = message+2;
  SJA_Message.TxBuffer[6] = message+3;
  SJA_Message.TxBuffer[7] = message+4;
  SJA_Message.TxBuffer[8] = message+5;
  SJA_Message.TxBuffer[9] = message+6;
  SJA_Message.TxBuffer[10] = message+7;
  message ++;
  sendQuery(&SJA_Message);
  //sendNow(&SJA_Message);
  lcd_WR_string(LCD_L4+8,"CANsent"); 
  
  delms(300); 
 }
 
void receive()
 {show(0,RD(RxBuffer3));
  show(3,getCanIE());
 }
 
void sendRTRMessage()
 {//show(2,getDistanz());
  SJA_Message.TxBuffer[0] = RTR_TC0;
  SJA_Message.TxBuffer[1] = RTR_TC1;
  SJA_Message.TxBuffer[2] = RTR_TC2;
  /* I send a sensorvalue as a sample */
  SJA_Message.TxBuffer[3] = 0x55; //getDistanz();
  SJA_Message.TxBuffer[4] = 0x00;
  SJA_Message.TxBuffer[5] = 0x00;
  SJA_Message.TxBuffer[6] = 0x00;
  SJA_Message.TxBuffer[7] = 0x00;
  SJA_Message.TxBuffer[8] = 0x00;
  SJA_Message.TxBuffer[9] = 0x00;
  SJA_Message.TxBuffer[10] = 0x00;
  sendQuery(&SJA_Message);
 }