//#include "i2cmaster.h"

void lcd_i2c_init(void)
{
	delms(40);
    i2c_WR(i2cLCDaddr,(1<<LCD_DB5));enable_i2c(); 
	i2c_WR(i2cLCDaddr,(1<<LCD_DB5));enable_i2c(); 
	i2c_WR(i2cLCDaddr,(1<<LCD_DB7));enable_i2c(); 
	delus(50);//50
	i2c_WR(i2cLCDaddr,0x00);enable_i2c(); 		 //Display ON/Off
	i2c_WR(i2cLCDaddr,0xF0);enable_i2c();	     //0xF0
	delus(50);//50
	i2c_WR(i2cLCDaddr,0x00);enable_i2c();		 //Clear Display 
	i2c_WR(i2cLCDaddr,0x60);enable_i2c();        //0x60
	delms(2);//2			
}
void enable_i2c (void)
{   u08 temp;
	temp=i2c_RD(i2cLCDaddr);
	//sprintf(s, "en-%X",temp);lcd_write_string(LCD_Line_4,&s[0]);
	sbi(temp,LCD_E);
	i2c_WR(i2cLCDaddr,temp);
	delus(10); //900  was recently 2
	cbi(temp,LCD_E);
	i2c_WR(i2cLCDaddr,temp);
}
void lcd_i2c_data (u08 sw)
{	
    u08 sw_backup = sw;u08 temp;
	sw &=0xF0;	 //delete lower nibble
	SETBIT(sw,LCD_RS);
	i2c_WR(i2cLCDaddr,sw);enable_i2c();
	sw_backup <<= 4;
	SETBIT(sw_backup,LCD_RS);
	i2c_WR(i2cLCDaddr,sw_backup);enable_i2c();

}
void lcd_i2c_command (u08 sw)
{	
    u08 sw_backup = sw;u08 temp;
	sw &=0xF0;	 //delete lower nibble
	i2c_WR(i2cLCDaddr,sw);enable_i2c();
	sw_backup <<= 4;
	i2c_WR(i2cLCDaddr,sw_backup);enable_i2c();
	
}
void lcd_WR_string(u08 where, char *what)
{
	int j;char ch;
	CLI();
	lcd_i2c_command(128 + where);	
	for(j=0;j<50;j++) {ch=*(what++);if(ch=='\0')break;lcd_i2c_data(ch);}
	SEI();
}
void lcd_WR_char(u08 where, char what)
{
	lcd_i2c_command(128 + where);lcd_i2c_data(what);
}
void lcd_goto(u08 where)
{
	lcd_i2c_command(128 + where);	
}
void lcd_i2c_update(void)
{
	lcd_i2c_init();	
}
void snake(u08 SnakeJoint)
{u08 place;
 for(place=0;place<=15;place++)
 {lcd_WR_char(LCD_L1+place, SnakeJoint);
  delms(10);
 }
 lcd_WR_char(LCD_L2+15, SnakeJoint);
 lcd_WR_char(LCD_L3+15, SnakeJoint);
 for(place=15;place>0;place--)
 {lcd_WR_char(LCD_L4+place, SnakeJoint);
  delms(10);
 }
 lcd_WR_char(LCD_L4, SnakeJoint);
 lcd_WR_char(LCD_L3, SnakeJoint);
 lcd_WR_char(LCD_L2, SnakeJoint);
 delms(40); 
}
