//Andreas Ortner ***a.ortner@freenet.de*** 12.03.2004 08:07:35
// Target : M32
// Gardenrain
typedef unsigned char  u08;

#define UCR UCSRB
//#define UCSRB UCR 
//#define UCSRA USR 
#define GIMSK GICR
#define uart_print() (&s)

/*** CAN****/
#define TIMING 0x02 /* 100kBaud, 24MHz Quarz */
#define IE_CONFIG 0xFF /* InterruptEnableRegister */

/* start Receiver mode */
#define ACR0 0xA1
#define ACR1 0x20
#define ACR2 0x00
#define ACR3 0x00
#define AMR0 0x00
#define AMR1 0x1F /* set the bit 4 XXX1 XXXX to receive RTR messages */
#define AMR2 0x00
#define AMR3 0x0F
#define MODE 0x00
#define TC0 0x08
#define TC1 0xA2
#define TC2 0x20

#define RTR_TC0 0x08
#define RTR_TC1 0xA1
#define RTR_TC2 0x20

char s[20]="Andr",s2[20]="ja";char s_empty[17]="             "; 
char *p_s=s;    
char Rx_buffer[30];char Rx_bit_number=0;char ascii_v[5]="34.3";
unsigned char KeyP_Buffer[7];u08 cur_menuPoint=0x00;u08 KeyP_in; //0-to menu, 1-to function
struct sct_time {unsigned char month; unsigned char day; unsigned char hour; unsigned char minute; unsigned char second; unsigned char msecond500; unsigned char msecond250; unsigned char msecond;};
struct sct_time time ={0,0,0,0,0,0,0,0};
struct sct_temperature{unsigned char range; unsigned char temperature_value;};
struct sct_temperature temperature={0,0};
unsigned int INT0_count, test=77,iX;char ch_x;
float fX;
unsigned int x;

#include <macros.h>
#include <STDIO.h>
#include <iom32v.h>
#include <STDLIB.h>
#include "STRING.H"
#include "uart.c"
#include <eeprom.h>

#include "miscelaneous.c"
#include "LCD_i2c.h"
#include "i2cmaster.c"
#include "LCD_i2c.c"
#include "keypad_i2c.c"
#include "ramconnect.c"
#include "CAN_functions.c"

void timer0_init(void);
void timer1_init(void);
void port_init(void);
void message_check(void);
void Init_ext_Interrupt(void);
void adc_init(unsigned char ADC_MUX);
int adc_conversation(unsigned char channel);
void get_temperature(unsigned char channel);

#pragma interrupt_handler INT0_ext_interrupt:2
#pragma interrupt_handler INT1_ext_interrupt:3
//#pragma interrupt_handler timer0_ovf_isr:8 //at AT90S8515
#pragma interrupt_handler timer0_ovf_isr:12
//#pragma interrupt_handler UART_RX_interrupt:10 //at AT90S8515
#pragma interrupt_handler UART_RX_interrupt:14 
#pragma interrupt_handler twi_isr:20

void UART_RX_interrupt( void )
{
	//printf("rec");
	//TransmitByte( UDR ); //CLEARBIT(UCSRA,RXC);
	if (UDR == '<'){Rx_bit_number=0; TransmitByte('<');}
	else {if (UDR == '>') {TransmitByte('>'); message_check();Rx_bit_number=0;}
	      else {Rx_buffer[Rx_bit_number++]=UDR;}}
}
void get_temperature(unsigned char channel)  //Linear + 10.0 mV/C scale factor
{
  float T_float=24.89;
  sprintf(s, "T%d",((adc_conversation(channel))/2));//lcd_write_string(LCD_Line_2+5,"    ");
  //sprintf(s, "T%f",T_float);//lcd_write_string(LCD_Line_2+5,"    ");
  lcd_WR_string(LCD_Line_1,&s[0]);
  printf("S %f", ((adc_conversation(channel))/2.1));
}
void adc_init(unsigned char ADC_MUX)
{
  ADCSR = 0x00; //disable adc
  //ADMUX = 0x00; //select adc input 0
  ADMUX=(ADMUX>>3);
  ADMUX=(ADMUX<<3);
  ADMUX|=ADC_MUX;//clear three right bits and overwright them with ADC_MUX
  ACSR = (1<<ACD);
  ADCSRA = ((1<<ADEN) | (1<<ADPS0))| (1<<ADATE) | (1<<ADSC); // 
}
int adc_conversation(unsigned char channel)
{
  unsigned int adc_value; 
  //CLEARBIT(ADCSRA,ADEN);//disable auto trigger
  ADMUX=(ADMUX>>3);
  ADMUX=(ADMUX<<3);
  ADMUX|=channel;//clear three right bits and overwright them with ADC_MUX
  //SETBIT(ADCSRA,ADEN);//enable auto trigger
  delus(5);
  adc_value =ADCL; 
  adc_value |=(ADCH<<8); 
  return adc_value;
}
void timer1_init(void)
{
  TCCR1B = 0x00; //stop
  TCNT1H = 0xFB; //setup
  TCNT1L = 0xFC;
  OCR1AH = 0x01;
  OCR1AL = 0x5F; //OCR1AL = 0x8F;
  OCR1BH = 0x04;
  OCR1BL = 0x04;
  TCCR1A = 0x81; // 8= PWM normal, 1= 8bit PWM
  TCCR1B = 0x0B; //start Timer clock  divider=256 
}
void Init_ext_Interrupt( )
	{
	//*******************PORTD.2 as INT0****************************
	MCUCR |= ((1<<ISC01)); /* The falling edge of INT0 */
	GICR |= (1<<INT0); //enable INT0 interrupt
	CLEARBIT(DDRD,2); //pin as input pull-up
	SETBIT(PORTD,2); 
	}	
void INT0_ext_interrupt(void)
{ 
  INT0_count++;	     
}	
void INT1_ext_interrupt(void)
{
  KeyP_evaluate();
} 
void timer0_ovf_isr(void)
{
 sysTimer();
}
void message_check(void)
{
 int x;unsigned char str_char[5]; x=5;
 sprintf(str_char ,"%c" ,'A'); Rx_bit_number=0;
 printf("message");
 uart_printstr( &Rx_buffer[0]);
 clear_string( &Rx_buffer[0]);
 }
void port_init(void)
{
 PORTB = 0xFF; DDRB  = 0xFF;
 PORTD = 0x00; DDRD  = 0xFF; 
}
void timer0_init(void)
{
 TCCR0 = 0x00; //stop
 TCNT0 = 0xC7; //set count
 //OCR0  = 0x39;  //set compare
 TCCR0 = 0x03; //start timer      //M32
}
void twi_isr(void)
{
 //twi event
}
 
 
 
 /********************* main************************/

void main( void )
 {
  int zahl=58;
  char str1[20]= "Andreas***";
  InitUART( 11 ); // set the baudrate to 19,200 bps using a 3.6864MHz crystal 
  UART_TRANSMIT_ON();	
  CLI(); //disable all interrupts 
  timer0_init(); 
  MCUCR = 0x00;
  GIMSK = 0x00;
  TIMSK = 0x02;		
  EEPROM_WRITE(0x01, zahl);
  EEPROM_READ(0x01, zahl);	
  port_init();
  timer1_init();
  Init_ext_Interrupt( );
  i2c_init();
  lcd_i2c_init();	
  SEI(); //re-enable interrupts
  init_keypad();
  //sprintf(s, "\nTest %d in %%\n\n", zahl); uart_printstr( &s[0]);
  //while ( 1 ) {//write_Bit_Port_toPort(2,PINA, PORTD);}
  //adc_init(1);
  //intro();
     
  /* Values for the initstructure */ 
  SJA_Init_Structure.Timing = TIMING; /* Network Timing */
  SJA_Init_Structure.ACR[0] = ACR0; SJA_Init_Structure.ACR[1] = ACR1;
  SJA_Init_Structure.ACR[2] = ACR2; SJA_Init_Structure.ACR[3] = ACR3;
  SJA_Init_Structure.AMR[0] = AMR0; SJA_Init_Structure.AMR[1] = AMR1;
  SJA_Init_Structure.AMR[2] = AMR2; SJA_Init_Structure.AMR[3] = AMR3;
  SJA_Init_Structure.Mode = MODE; /* Mode */
  SJA_Init_Structure.InterruptEnable = IE_CONFIG; /* Interrupt Enable */
  

  init_ramconnect();  /* enable also Pin5 - 7 for the SJARamcontrol */
  
  //outp( ISC11| ISC01 | ISC00 , MCUCR); /*enable External SRAM and set the interrupt1 on faling edge for the SJA */
  //SEI(); /* Enable all Interrupts */
  //sbi(PORTD,PIND3); /* set the Interruptpin on the PortD on high so that the SJA can work with a faling edge */
  //cbi(GIMSK,INT1); /* disable Interrupt1 on PD3 for SJA1000 interrupts during initializion */ 
  
  //initSJA(&SJA_Init_Structure); //start of Initialization of the SJA1000 
  
  //sbi(GIMSK,INT1); /* enable Interrupt1 on PD3 for SJA1000 interrupts after initializion */
  
  //i2c_WR(i2cLCDaddr,(0x55)); 
  intro();
  menuGuide();	
 }
