#include "keypad_i2c.h"

char keypad_scan(void)
{
 	char scan_buff,key='n';
	CLEARBIT(scan_buff,KEYP_C1);SETBIT(scan_buff,KEYP_C2);SETBIT(scan_buff,KEYP_C3);
	i2c_WR(i2cKPaddr,0xFE);
	delus(1000);//short delay of 100s is required when changing the port B I/O contiguration to allow time for the pin values to settle
	scan_buff=i2c_RD(i2cKPaddr);
	scan_buff=scan_buff>>4;
		
	switch(scan_buff) //switch(scan_buff=(KEYP_PIN>>4))
	 {case 0x0F:break;
	  case 0x0E:key='1';break;
	  case 0x0D:key='4';break;
	  case 0x0B:key='7';break;
	  case 0x07:key='*';break;
	  default: KEYP_PORT=0b11111101;
	 }	
	
	//SETBIT(KEYP_PORT,KEYP_C1);CLEARBIT(KEYP_PORT,KEYP_C2);SETBIT(KEYP_PORT,KEYP_C3);
	i2c_WR(i2cKPaddr,0xFD);
	delus(1000); // it was previous by 1000 
	scan_buff=i2c_RD(i2cKPaddr);
	scan_buff=scan_buff>>4;
	switch(scan_buff)
	 {case 0x0F:break;
	  case 0x0E:key='2';break;
	  case 0x0D:key='5';break;
	  case 0x0B:key='8';break;
	  case 0x07:key='0';break;
	 }	 
	 //SETBIT(KEYP_PORT,KEYP_C1);SETBIT(KEYP_PORT,KEYP_C2);CLEARBIT(KEYP_PORT,KEYP_C3);
	
	i2c_WR(i2cKPaddr,0xFB);
	delus(1000);
	scan_buff=i2c_RD(i2cKPaddr);
	scan_buff=scan_buff>>4;
	switch(scan_buff)
	 {case 0x0F:break;
	  case 0x0E:key='3';break;
	  case 0x0D:key='6';break;
	  case 0x0B:key='9';break;
	  case 0x07:key='#';break;
	 } 	 
	 //CLEARBIT(KEYP_PORT,KEYP_C1);CLEARBIT(KEYP_PORT,KEYP_C2);CLEARBIT(KEYP_PORT,KEYP_C3);
	 
	 delms(30); //delms(100)30 hat auch funk
	 i2c_WR(i2cKPaddr,0x0F);
	 KP_Button=key;
	 return key;
	
}
void init_keypad(void)
{
 	i2c_WR(i2cKPaddr,0x0F);
	
	SETBIT(MCUCR,ISC11);CLEARBIT(MCUCR,ISC10);//enable falling edge
	SETBIT(GICR,INT1);//enable INT1
	CLEARBIT(DDRD,2);
	SETBIT(PORTD,2); 
}

void KeyP_evaluate(void)
{
 char key[2];
 key[1]=0;
 CLI();
 key[0]=keypad_scan();
 if (KeyP_in==0 & key[0]!='n'){ // if Keypad should go to Menu, then ...
  KeyP_Buffer[0]=key[0];
 }
 else{ 
  if (key[0]=='#'){iX=atoi(&KeyP_Buffer[0]);OCR1AL=iX;sprintf(s, "KP%d",iX);lcd_WR_string(LCD_Line_4,&s[0]);}
  if (!(key[0]=='n')){strcat(KeyP_Buffer,key);}
  if (key[0]=='#'){clear_string(&KeyP_Buffer[0]);}
  
 }     
 SEI();
}   
u08 key(u08 TestForKey)
{u08 key_ret=KeyP_Buffer[0];
 if (TestForKey==KeyP_Buffer[0])
   {KeyP_Buffer[0]=0;
    return 1;
   } 	
 else return 0;  
}