
#include "LCD_i2c.h"
#include "i2cmaster.h"
#include "keypad_i2c.h"

void sysTimer(void)
{
 TCNT2 = 0xC2; //reload counter value
 time.msecond++;
 if(time.msecond == 250)//  1/4 of second
  {time.msecond = 0;
   time.msecond250++;
   if(time.msecond250 == 2) // 1/2 of second
    {time.msecond250 = 0;
     time.msecond500++;	 
     if(time.msecond500 == 2) //1 second
      {time.msecond500 = 0; 
	   //time.second++;
	   
	   //sprintf(s, "Pot1=%d",((adc_conversation(0)*10)/44));lcd_write_string(LCD_Line_2,&s[0]);
	   //sprintf(s, "Pot2=%d",((adc_conversation(1)*10)/44));//lcd_write_string(LCD_Line_3+5,"    ");
	   //OCR1AL=adc_conversation(1)/36*20;
	   //sprintf(s, "Pot2=%d",(adc_conversation(1)/36*20));//lcd_write_string(LCD_Line_3+5,"    ");
	   //OCR1AL=time.second*4;
	   //lcd_WR_string(LCD_Line_3,&s[0]);
	   //iX=atoi(&ascii_v[0]);sprintf(s, "i %+*5.2d",iX);lcd_write_string(LCD_Line_4,&s[0]);
	   //fX=42.216;sprintf(s, "f %6.3f",fX);lcd_write_string(LCD_Line_4+8,&s[0]);	
	   //printf("S%d ", time.second);
	   //get_temperature(2);	  
	   //printf("U= %d ",(INT0_count*60) );INT0_count=0; //Undrehungen/Minute
	   //printf("ADC%d ",(adc_conversation()*2) );
	   //sprintf(s, "Pot1=%d ", (adc_conversation()*2));lcd_write_string(LCD_Line_3,&s[0]);
	   //OCR1AL+=10;
	   //lcd_i2c_print_time(); 
	   
	   /*if(time.second == 60)
	    {time.second = 0; 
	     time.minute++;
	     if(time.minute == 60)
	      {time.minute = 0; 
	       time.hour++;
		   if(time.hour == 24)
	        {time.hour = 0;} 
		  }
        }*/
     } 
   } 	 	 
 }	        
}

u08 findSettedBitNumberOfByte(u08 givenByte)
 {u08 bitNumberOfGivenByte,i;  
   for(bitNumberOfGivenByte=0;;bitNumberOfGivenByte++)
   {
    if(givenByte==1)break;
	else givenByte>>=1;
   }
  return bitNumberOfGivenByte; 
 }

void clear_string(char *p_str)
{
	char j; 
	for(j=0;j<100;j++) {*p_str++ = 0;if(*p_str=='\0')break;} 
}
void delms(int ms)
{
		int k,m,n,j;
   		for(k=0;k<ms;k++)
   			for(m=0;m<7;m++) //1ms
   				for(n=0;n<255;n++) j++;		
}
void delus(int us)
{
	int n,j;
   	for(n=0;n<us;n++) j++;			
}
void write_Bit_Port_toPort(unsigned char bit_no,volatile unsigned char port_from,volatile unsigned char port_to )
{
	unsigned char xx;unsigned char port_to_copied;
	if (xx=port_from & (1<<bit_no)){port_to|=xx;}//if bit to be set, then set
	else{port_to&=~xx;}  //if bit to be cleared, then clear
	
}
void write_Bit_Port_to_Bit_Port(unsigned char bit_no_from,  unsigned char port_from,unsigned char bit_no_to,  unsigned char port_to )
{
	unsigned char x;unsigned char port_to_copied;
	
	
}

void intro(void)
{
 	 //lcd_i2c_command(LCD_clear_display);
	 lcd_WR_string(LCD_Line_1,"***GRH AO06***");
	 delms(100);
	 lcd_i2c_command(LCD_clear_display);
	 lcd_WR_string(LCD_Line_1,"**Ortner");lcd_WR_string(LCD_Line_2,"electronics**");
	 delms(100);
	 lcd_WR_string(LCD_Line_3,"engineered by");
	 lcd_WR_string(LCD_Line_4,"Andreas Ortner");
	 delms(100);
	 lcd_i2c_command(LCD_clear_display);
	 lcd_WR_string(LCD_Line_2,"   ***2006***");
	 delms(200);
	 lcd_i2c_command(LCD_clear_display);
}

void menu0(void)
{
 		 
}
void doNothing(void){lcd_WR_string(LCD_L4,"doNoth");}
void menuView(void)
{
 lcd_WR_string(LCD_L2,menu[cur_menuPoint].text);lcd_WR_string(LCD_L2,">");
 if(menu[cur_menuPoint].up==menu[cur_menuPoint+1].up){lcd_WR_string(LCD_L3,menu[cur_menuPoint+1].text);}
 else{lcd_WR_string(LCD_L4,&s_empty[0]);}
 if(menu[cur_menuPoint].up==menu[cur_menuPoint+2].up){lcd_WR_string(LCD_L4,menu[cur_menuPoint+2].text);}
 else{lcd_WR_string(LCD_L4,&s_empty[0]);}
}
void menuGuide(void)
{
 	 KeyP_in=0;
	 cur_menuPoint=FIRST_OP_MENUE;
	 lcd_i2c_command(LCD_clear_display); 
	 lcd_i2c_command(LCD_blink_on_cur_on);
	 KeyP_Buffer[0]=OK;
	 menu[cur_menuPoint].pToFunction();
	 menuView();	 
	 while(1) //KeyP_in==0
	 {switch(KeyP_Buffer[0]) 
	  {case UP:
	   {KeyP_Buffer[0]=0;
	    cur_menuPoint=menu[cur_menuPoint].up;
	    menuView();
		break;
	   }   
	   case DOWN:
	   {KeyP_Buffer[0]=0;
	    cur_menuPoint=menu[cur_menuPoint].down;
	    menuView();
		break;
	   } 
	   case PREV:
	   {KeyP_Buffer[0]=0;
	    cur_menuPoint=menu[cur_menuPoint].previous;
	    menuView();
		break;
	   }
	   case NEXT:
	   {KeyP_Buffer[0]=0;
	    cur_menuPoint=menu[cur_menuPoint].next;
	    menuView();
		break;
	   }
	   case OK:
	   {KeyP_Buffer[0]=0;
		lcd_i2c_command(LCD_clear_display);
		lcd_WR_string(LCD_L1,menu[cur_menuPoint].text);
		menu[cur_menuPoint].pToFunction();
		//cur_menuPoint=menu[cur_menuPoint].previous;
		lcd_i2c_command(LCD_clear_display);
		menuView();
		break;
	   }
	  }
	}
}

void SetBits()
{
 u08 key=0,bit_number=1,x_Byte;
 lcd_WR_string(LCD_L3+4,"76543210");
 lcd_goto(LCD_L3+11);
 i2c_WR(i2cPortA,(!0x01));
 //key=wait_for_key();
  while(!(ESC==KeyP_Buffer[0]))
 {
   //for(key=1;key<255;key+=2){i2c_WR(i2cPortA,key);delms(100);}
   switch(KeyP_Buffer[0]) 
   {   case PREV:
	   {KeyP_Buffer[0]=0;
	    bit_number<<=1;
		if(bit_number==0)bit_number=1;
		lcd_goto(LCD_L3+11-findSettedBitNumberOfByte(bit_number)); 
		break;
	   }   
	   case OK:
	   {KeyP_Buffer[0]=0;
	    x_Byte=i2c_RD(i2cPortA);
		x_Byte^=bit_number;
		i2c_WR(i2cPortA,x_Byte);
		break;
	   } 
   }
 }
 KeyP_Buffer[0]=0; 
}

u08 wait_for_key()
{u08 key=0;
 while(!((key == UP) || (key == DOWN) || (key == PREV) || (key == NEXT) || (key == OK) || (key == ESC)) )  
  {switch(KeyP_Buffer[0]) 
   {   case UP:
	   {key=UP;
	    KeyP_Buffer[0]=0;
		break;
	   }   
	   case DOWN:
	   {key=DOWN;
	    KeyP_Buffer[0]=0;
		break;
	   } 
	   case PREV:
	   {key=PREV;
	    KeyP_Buffer[0]=0;
		break;
	   }
	   case NEXT:
	   {key=NEXT;
	    KeyP_Buffer[0]=0;
		break;
	   }
	   case OK:
	   {key=OK;
	   KeyP_Buffer[0]=0;
		break;
	   }
	   case ESC:
	   {key=ESC;
	    //KeyP_Buffer[0]=0;
	   }
   }   	   
 }
 return key;
}

void readFromPCF8591(void)
 {u08 DAC_value=0;
 
  while(!(ESC==KeyP_Buffer[0]))
  {DAC_value=DAC_value+1;
   lcd_i2c_command(LCD_clear_display);
   //i2c_RD(i2cAnaPortA);
   i2c_WR(i2cAnaPortA,PCF8591_CHANNEL1);
   sprintf(s, "Analog1=%d",i2c_RD(i2cAnaPortA));
   lcd_WR_string(LCD_L3,&s[0]);
   i2c_WR(i2cAnaPortA,PCF8591_CHANNEL0);
   sprintf(s, "Analog0=%d",i2c_RD(i2cAnaPortA));
   lcd_WR_string(LCD_L2,&s[0]);
   
   I2C_PCF8591Write(i2cAnaPortA, ANALOG_OUTPUT_ENABLE, DAC_value);
   //i2c_WR(i2cAnaPortA,DAC_value++);
   //delms(30);
  }
  KeyP_Buffer[0]=0; 
 }
 
 void ShowTemerature(void)
 {u08 DAC_value=0;
 
  while(!(ESC==KeyP_Buffer[0]))
  {DAC_value=DAC_value+1;
   lcd_i2c_command(LCD_clear_display);
   //i2c_RD(i2cAnaPortA);
   i2c_WR(i2cAnaPortA,PCF8591_CHANNEL0);
   i2c_RD(i2cAnaPortA);
   sprintf(s, "Poti_1=%d",i2c_RD(i2cAnaPortA)+1);
   lcd_WR_string(LCD_L2,&s[0]);
   
   i2c_WR(i2cAnaPortA,PCF8591_CHANNEL1);
   i2c_RD(i2cAnaPortA);
   sprintf(s, "Poti_2=%d",i2c_RD(i2cAnaPortA)+1);
   lcd_WR_string(LCD_L3,&s[0]);
   
   i2c_WR(i2cAnaPortA,PCF8591_CHANNEL2);
   i2c_RD(i2cAnaPortA);
   sprintf(s, "Light int.=%d",68-(i2c_RD(i2cAnaPortA)));
   strcat(s,"%");
   lcd_WR_string(LCD_L4,&s[0]);
   
   delms(50);
  }
  KeyP_Buffer[0]=0; 
 }

  void ShowTemerature_i2c(void)
 {u08 DAC_value=0;
 
  while(!(ESC==KeyP_Buffer[0]))
  {
   //lcd_i2c_command(LCD_clear_display);
   //i2c_RD(i2cAnaPortA);
   //i2c_LM75_TemperRead(i2cTemper);
   
   //sprintf(s, "TemperByt1=%d",temperature.range);
   //sprintf(s, "Temperat/2=%d",i2c_LM75_TemperRead(i2cTemper));
   //lcd_WR_string(LCD_L2,&s[0]);
  }
  KeyP_Buffer[0]=0; 
 }
 
void ShowTime_i2c(void)
{
 sprintf(s, "Press # for menu");
 lcd_WR_string(LCD_L4,&s[0]);
 while(!(ESC==KeyP_Buffer[0]))
  {//i2c_PCF8573_TimeRD (i2cRTC); 
   lcd_i2c_print_time();
   
   delms(50);
  }
  KeyP_Buffer[0]=0; 
}

void ShowAlarm_i2c(void)
{
 while(!(ESC==KeyP_Buffer[0]))
  {i2c_PCF8573_AlarmRD (i2cRTC); 
   lcd_i2c_print_time();
   
   delms(50);
  }
  KeyP_Buffer[0]=0; 
}

u08 BCD_to_char (u08 BCD)
{u08 UpperDigit=0;
 UpperDigit=BCD;
 UpperDigit>>=4; 
 UpperDigit*=10;
 BCD&=0x0F;
 BCD+=UpperDigit;
 return BCD;
}
u08 char_to_BCD (u08 given_char)
{u08 UpperDigit=0, LowerDigit=0;
 LowerDigit=given_char % 10;
 UpperDigit=given_char / 10;
 UpperDigit<<=4;
 LowerDigit|=UpperDigit;
 return LowerDigit; 
}
void lcd_i2c_print_time(void)
{
	sprintf(s, "%d", time.day);
	sprintf(s2, "/%d", time.month);
	strcat(s,s2);
	sprintf(s2, " %d", time.hour);
	strcat(s,s2);
	sprintf(s2, ":%d", time.minute);
	strcat(s,s2);
	lcd_WR_string(LCD_L4+7,&s[0]);
	
	/*
	sprintf(s, "%d", time.hour);
	sprintf(s2, ":%d", time.minute);
	strcat(s,s2);
	//sprintf(s2, ":%d", time.second);
	//strcat(s,s2);
	//lcd_WR_string(LCD_L2+5,"      "); //delete place to write
	lcd_WR_string(LCD_L4+5,&s[0]);
	*/
	
	/*sprintf(s, "%d", time.hour);sprintf(s2, ":%d", time.minute);
	strcat(s,s2);sprintf(s2, ":%d", time.second);strcat(s,s2);
	lcd_WR_string(LCD_L2+5,"      "); //delete place to write
	lcd_WR_string(LCD_L4,&s[0]);
	sprintf(s, "%d", time.year);sprintf(s2, "-%d", time.month);
	strcat(s,s2);sprintf(s2, "-%d", time.day);strcat(s,s2);
	lcd_WR_string(LCD_L3,&s[0]);
	switch(time.weekday) //
	 {case 1: sprintf(s, "Mon");break;
	  case 2: sprintf(s, "Tue");break;
	  case 3: sprintf(s, "Wed");break;
	  case 4: sprintf(s, "Thu");break;
	  case 5: sprintf(s, "Fri");break;
	  case 6: sprintf(s, "Sat");break;
	  case 7: sprintf(s, "Sun");
	 }	
	lcd_WR_string(LCD_L3+11,&s[0]);
	*/ 	
}
void SetClock (void)
{  i2c_PCF8573_TimeRD (i2cRTC);
   lcd_i2c_print_time();
   lcd_goto(LCD_L2);
   SetupVariable(&time.hour);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | TIME_HOUR,char_to_BCD (time.hour));
   SetupVariable(&time.minute);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | TIME_MINUTE,char_to_BCD (time.minute));
   //SetupVariable(&time.second);	
   lcd_goto(LCD_L3);
   SetupVariable(&time.month);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | TIME_MONTH,char_to_BCD (time.month));
   SetupVariable(&time.day);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | TIME_DAY,char_to_BCD (time.day));
   snake('*');
} 

void SetAlarm (void)
{  i2c_PCF8573_TimeRD (i2cRTC);
   lcd_i2c_print_time();
   lcd_goto(LCD_L2);
   SetupVariable(&time.hour);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | ALARM_HOUR,char_to_BCD (time.hour));
   SetupVariable(&time.minute);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | ALARM_MINUTE,char_to_BCD (time.minute));
   SetupVariable(&time.second);	
   SetupVariable(&time.month);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | ALARM_MONTH,char_to_BCD (time.month));
   SetupVariable(&time.day);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | ALARM_DAY,char_to_BCD (time.day));
   snake('*');
}

void SetupThermostat(void)
{u08 counter, counter_2;
 i2c_WR(i2cTemper,TemperatureRead);
 counter=i2c_RD(i2cTemper);
 sprintf(s, "Temperature=%d", i2c_RD(i2cTemper));
 lcd_WR_string(LCD_Line_2,&s[0]);
 
 sprintf(s, "O.S.Level=%d", i2c_RD(i2cTemper));
 lcd_WR_string(LCD_Line_3,&s[0]);
   while(!(OK==KeyP_Buffer[0]))
    {if (UP==KeyP_Buffer[0]){counter++;KeyP_Buffer[0]=0;sprintf(s, "O.S.Level=%d", counter);lcd_WR_string(LCD_Line_3,&s[0]);}
     delms(50);
    }
    KeyP_Buffer[0]=0;
	
    i2c_WR(i2cTemper,T_os);
	i2c_WR_2Bytes(i2cTemper,counter,0);
	counter=i2c_RD_2Bytes(i2cTemper);
    sprintf(s, "%d", counter);
    lcd_WR_string(LCD_Line_3+1,&s[0]);
	  
    lcd_WR_string(LCD_Line_4,"T.hystLevel=0");
   while(!(OK==KeyP_Buffer[0]))
    {if (UP==KeyP_Buffer[0]){counter++;KeyP_Buffer[0]=0;sprintf(s, "T.hystLevel=%d", counter);lcd_WR_string(LCD_Line_4,&s[0]);}
     if (DOWN==KeyP_Buffer[0]){counter--;KeyP_Buffer[0]=0;sprintf(s, "T.hystLevel=%d", counter);lcd_WR_string(LCD_Line_4,&s[0]);}
     delms(50);
    }
    KeyP_Buffer[0]=0; 
	
    i2c_WR(i2cTemper,T_hyst);
	i2c_WR_2Bytes(i2cTemper,counter,0);      
    counter=i2c_RD_2Bytes(i2cTemper);
    sprintf(s, "%d", counter);
    lcd_WR_string(LCD_Line_4+1,&s[0]);
	  
    delms(1000);
}
void SetupVariable(char *pTo)
{
 while(!key(OK))
    {if (key(UP)){*pTo=*pTo+1;if(*pTo==60)*pTo=0;lcd_i2c_print_time();}
     if (key(DOWN)){*pTo=*pTo-1;if(*pTo==255)*pTo=60;lcd_i2c_print_time();}
	 delms(50);
    }
}

void beep(void)
{


}

void Door(void)
{
lcd_i2c_command(LCD_clear_display);
//if(								   lcd_WR_string(LCD_Line_2,"   ***2004***");

 while(!key(OK))
    {if (key(UP)){}
     if (key(DOWN)){}
	 delms(50);
    }

   
   lcd_goto(LCD_L2);
   SetupVariable(&time.hour);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | TIME_HOUR,char_to_BCD (time.hour));
   SetupVariable(&time.minute);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | TIME_MINUTE,char_to_BCD (time.minute));
   //SetupVariable(&time.second);	
   lcd_goto(LCD_L3);
   SetupVariable(&time.month);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | TIME_MONTH,char_to_BCD (time.month));
   SetupVariable(&time.day);
   i2c_WR_2Bytes(i2cRTC,EXEC_ADDR | TIME_DAY,char_to_BCD (time.day));
   snake('*');

}

