/*Written by Andreas Ortner
 4 bit Modus*/

#define i2cLCDaddr 0x39 
//0111 001
#define LCD_RS 2
#define LCD_E 3
#define LCD_DB4 4
#define LCD_DB5 5
#define LCD_DB6 6
#define LCD_DB7 7
#define LCD_Line_1 0x00
#define LCD_Line_2 0x40
#define LCD_Line_3 0x10
#define LCD_Line_4 0x50

#define LCD_L1 0x00
#define LCD_L2 0x40
#define LCD_L3 0x10
#define LCD_L4 0x50
/* commands  */
#define LCD_clear_display 1
#define LCD_cursor_at_home 2
#define LCD_blink_off_cur_on 0x0E
#define LCD_blink_off_cur_off 0x0C
#define LCD_blink_on_cur_on 0x0D

#define LCD_print(str)	lcd_WR_string(LCD_Line_1,str)


void delms(int);
void delus(int);

void lcd_i2c_init(void);
void enable_i2c(void);
void lcd_i2c_data (u08);
void lcd_i2c_command (u08);
void lcd_WR_string(u08, char *what);
void lcd_WR_char(u08 where, char what);
void i2c (u08 address,u08 data);
void lcd_goto(u08 where);
void lcd_i2c_update(void);
void snake(u08 SnakeJoint);

