/* Keypad 3Columns * 4rows
   I had Problems with the PortB, it had a function just with the first row
*/
//#include "LCD.h"
#define KEYP_PORT PORTA
#define KEYP_DDR DDRA
#define KEYP_PIN PINA
#define KEYP_C1 0
#define KEYP_C2 1
#define KEYP_C3 2
#define KEYP_EXTINT 3
#define KEYP_R1 4
#define KEYP_R2 5
#define KEYP_R3 6
#define KEYP_R4 7
char keypad_scan(void);
char keypad_scan(void)
{
 	char scan_buff,key;
	//sprintf(s, "Test %d ", test);lcd_write_string(LCD_Line_4,&s[0]);
	CLEARBIT(KEYP_PORT,KEYP_C1);SETBIT(KEYP_PORT,KEYP_C2);SETBIT(KEYP_PORT,KEYP_C3);
	delus(100);//short delay of 100s is required when changing the port B I/O contiguration to allow time for the pin values to settle
	switch(scan_buff=(KEYP_PIN>>4))
	 {case 0x0F:break;
	  case 0x0E:key='1'; lcd_write_string(LCD_Line_4+15,"1");break;
	  case 0x0D:key='4'; lcd_write_string(LCD_Line_4+15,"4");break;
	  case 0x0B:key='7'; lcd_write_string(LCD_Line_4+15,"7");break;
	  case 0x07:key='*'; lcd_write_string(LCD_Line_4+15,"*");break;
	  default: KEYP_PORT=0b11111101;
	 }	
	SETBIT(KEYP_PORT,KEYP_C1);CLEARBIT(KEYP_PORT,KEYP_C2);SETBIT(KEYP_PORT,KEYP_C3);
	delus(100);
	switch(scan_buff=(KEYP_PIN>>4))
	 {case 0x0F:break;
	  case 0x0E:key='2'; lcd_write_string(LCD_Line_4+15,"2");break;
	  case 0x0D:key='5'; lcd_write_string(LCD_Line_4+15,"5");break;
	  case 0x0B:key='8'; lcd_write_string(LCD_Line_4+15,"8");break;
	  case 0x07:key='0'; lcd_write_string(LCD_Line_4+15,"0");break;
	 }	 
	 SETBIT(KEYP_PORT,KEYP_C1);SETBIT(KEYP_PORT,KEYP_C2);CLEARBIT(KEYP_PORT,KEYP_C3);
	delus(100);
	switch(scan_buff=(KEYP_PIN>>4))
	 {case 0x0F:break;
	  case 0x0E:key='3'; lcd_write_string(LCD_Line_4+15,"3");break;
	  case 0x0D:key='6'; lcd_write_string(LCD_Line_4+15,"6");break;
	  case 0x0B:key='9'; lcd_write_string(LCD_Line_4+15,"9");break;
	  case 0x07:key='#'; lcd_write_string(LCD_Line_4+15,"#");break;
	 } 	 
	 CLEARBIT(KEYP_PORT,KEYP_C1);CLEARBIT(KEYP_PORT,KEYP_C2);CLEARBIT(KEYP_PORT,KEYP_C3);
	 delms(100);
	 return key;
}
void init_keypad(void)
{
 	SETBIT(KEYP_DDR,0);SETBIT(KEYP_DDR,1);SETBIT(KEYP_DDR,2);CLEARBIT(KEYP_DDR,4);CLEARBIT(KEYP_DDR,5);CLEARBIT(KEYP_DDR,6);CLEARBIT(KEYP_DDR,7);
	//DDRB=0x0F;
	CLEARBIT(KEYP_PORT,0);CLEARBIT(KEYP_PORT,1);CLEARBIT(KEYP_PORT,2);SETBIT(KEYP_PORT,4);SETBIT(KEYP_PORT,5);SETBIT(KEYP_PORT,6);SETBIT(KEYP_PORT,7);      
	//PORTB=0xF0;
	//MCUCR=0x08;
	SETBIT(MCUCR,ISC11);CLEARBIT(MCUCR,ISC10);//enable falling edge
	SETBIT(GICR,INT1);//enable INT1
	CLEARBIT(DDRD,3);
	SETBIT(PORTD,3); 
}
